<template>
  <PageWrapper dense>
    <Row>
      <!-- 左边部门选择 -->
      <Col v-bind="{ xs: 24, sm: 24, md: 24, lg: 4 }" class="h-[calc(100vh-80px)]">
        <FunctionInfoDeptTree
          v-model:selectDeptId="selectDeptId"
          v-model:searchValue="searchValue"
          @select="reload"
        />
      </Col>
      <Col v-bind="{ xs: 24, sm: 24, md: 24, lg: 20 }">
        <BasicTable @register="registerTable">
          <template #toolbar>
            <a-button
              @click="
                downloadExcel(
                  functionInfoExport,
                  '职能部门信息;数据',
                  getForm().getFieldsValue()
                )
              "
              v-auth="'elevator:functionInfo:export'"
              >导出</a-button
            >
            <a-button
              type="primary"
              danger
              @click="multipleRemove(functionInfoRemove)"
              :disabled="!selected"
              v-auth="'elevator:functionInfo:remove'"
              >删除</a-button
            >
            <a-button
              type="primary"
              @click="handleAdd"
              v-auth="'elevator:functionInfo:add'"
              >新增</a-button
            >
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'action'">
              <TableAction
                stopButtonPropagation
                :actions="[
                  {
                    label: '查看',
                    icon: IconEnum.PREVIEW,
                    type: 'primary',
                    ghost: true,
                    auth: 'function:functionInfo:query',
                    onClick: handCheck.bind(null, record),
                  },
                  {
                    label: '修改',
                    icon: IconEnum.EDIT,
                    type: 'primary',
                    ghost: true,
                    auth: 'elevator:functionInfo:edit',
                    onClick: handleEdit.bind(null, record),
                  },
                  {
                    label: '删除',
                    icon: IconEnum.DELETE,
                    type: 'primary',
                    danger: true,
                    ghost: true,
                    auth: 'elevator:functionInfo:remove',
                    popConfirm: {
                      placement: 'left',
                      title: '是否删除职能部门信息;[' + record.id + ']?',
                      confirm: handleDelete.bind(null, record),
                    },
                  },
                ]"
              />
            </template>
          </template>
        </BasicTable>
      </Col>
    </Row>

    <FunctionInfoModal @register="registerModal" @reload="reload" />
  </PageWrapper>
</template>

<script setup lang="ts">
import { Row, Col } from "ant-design-vue";
import { PageWrapper } from "@/components/Page";
import { BasicTable, useTable, TableAction } from "@/components/Table";
import {
  functionInfoList,
  functionInfoExport,
  functionInfoRemove,
} from "@/api/basicInfo/funcDepartment";
import { downloadExcel } from "@/utils/file/download";
import { useModal } from "@/components/Modal";
import FunctionInfoModal from "./FunctionInfoModal.vue";
import { formSchemas, columns } from "./functionInfo.data";
import { IconEnum } from "@/enums/appEnum";
import FunctionInfoDeptTree from "./FunctionInfoDeptTree.vue";
import { ref, toValue } from "vue";
defineOptions({ name: "FunctionInfo" });
// 左边部门用
const selectDeptId = ref<string[]>([]);
const searchValue = ref<string>("");
const [registerTable, { reload, multipleRemove, selected, getForm }] = useTable({
  rowSelection: {
    type: "checkbox",
  },
  title: "职能部门信息;列表",
  api: functionInfoList,
  showIndexColumn: true,
  rowKey: "id",
  useSearchForm: true,
  formConfig: {
    schemas: formSchemas,
    baseColProps: {
      xs: 24,
      sm: 24,
      md: 24,
      lg: 6,
    },
    resetFunc: async () => {
      selectDeptId.value = [];
      searchValue.value = "";
      await reload();
    },
  },
  columns: columns,
  // 需要添加上部门参数
  beforeFetch(params: Recordable) {
    if (toValue(selectDeptId).length === 1) {
      params.deptId = toValue(selectDeptId)[0];
    }
    return params;
  },
  actionColumn: {
    width: 250,
    title: "操作",
    key: "action",
    fixed: "right",
  },
});

const [registerModal, { openModal }] = useModal();

function handleEdit(record: Recordable) {
  openModal(true, { record, update: 1 });
}

function handleAdd() {
  openModal(true, { update: 2 });
}
function handCheck(record: Recordable) {
  openModal(true, { record, update: 3 });
}
async function handleDelete(record: Recordable) {
  await functionInfoRemove([record.id]);
  await reload();
}
</script>

<style scoped></style>
